Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_surf.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_surf.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_surf.F90	(revision 15764)
@@ -39,6 +39,6 @@
 
    SUBROUTINE obs_rea_surf( surfdata, knumfiles, cdfilenames, &
-      &                     kvars, kextr, kstp, ddobsini, ddobsend, &
-      &                     ldignmis, ldmod, ldnightav )
+      &                     kvars, kextr, kstp, ddobsini, ddobsend, MeanPeriodHours, &
+      &                     ldignmis, ldmod, ldnightav, ldclim, ln_time_mean_sla_bkg, cdvars )
       !!---------------------------------------------------------------------
       !!
@@ -71,14 +71,19 @@
       LOGICAL, INTENT(IN) :: ldmod      ! Initialize model from input data
       LOGICAL, INTENT(IN) :: ldnightav  ! Observations represent a night-time average
+      LOGICAL, INTENT(IN) :: ldclim     ! Will include climatology at obs points.
+      LOGICAL, INTENT(IN) :: ln_time_mean_sla_bkg     ! Will reset times to end of averaging period.
       REAL(dp), INTENT(IN) :: ddobsini   ! Obs. ini time in YYYYMMDD.HHMMSS
       REAL(dp), INTENT(IN) :: ddobsend   ! Obs. end time in YYYYMMDD.HHMMSS
+      REAL(wp), INTENT(IN) :: MeanPeriodHours ! Averaging period in hours
+      CHARACTER(len=8), DIMENSION(kvars), INTENT(IN) :: cdvars
 
       !! * Local declarations
       CHARACTER(LEN=11), PARAMETER :: cpname='obs_rea_surf'
       CHARACTER(len=8) :: clrefdate
-      CHARACTER(len=8), DIMENSION(:), ALLOCATABLE :: clvars
+      CHARACTER(len=8), DIMENSION(:), ALLOCATABLE :: clvarsin
       INTEGER :: ji
       INTEGER :: jj
       INTEGER :: jk
+      INTEGER :: jvar
       INTEGER :: iflag
       INTEGER :: inobf
@@ -103,8 +108,9 @@
          & ityp, &
          & itypmpp
-      INTEGER, DIMENSION(:), ALLOCATABLE :: &
+      INTEGER, DIMENSION(:,:), ALLOCATABLE :: &
          & iobsi,    &
          & iobsj,    &
-         & iproc,    &
+         & iproc
+      INTEGER, DIMENSION(:), ALLOCATABLE :: &         
          & iindx,    &
          & ifileidx, &
@@ -122,5 +128,6 @@
       TYPE(obfbdata), POINTER, DIMENSION(:) :: &
          & inpfiles
-
+      CHARACTER(LEN=256) :: cout1  ! Diagnostic output line
+      
       ! Local initialization
       iobs  = 0
@@ -181,4 +188,9 @@
                &                ldgrid = .TRUE. )
 
+            IF ( inpfiles(jj)%nvar /= kvars ) THEN
+               CALL ctl_stop( 'Feedback format error: ', &
+                  &           ' unexpected number of vars in feedback file' )
+            ENDIF
+
             IF ( ldmod .AND. ( inpfiles(jj)%nadd == 0 ) ) THEN
                CALL ctl_stop( 'Model not in input data' )
@@ -187,11 +199,15 @@
 
             IF ( jj == 1 ) THEN
-               ALLOCATE( clvars( inpfiles(jj)%nvar ) )
+               ALLOCATE( clvarsin( inpfiles(jj)%nvar ) )
                DO ji = 1, inpfiles(jj)%nvar
-                 clvars(ji) = inpfiles(jj)%cname(ji)
+                 clvarsin(ji) = inpfiles(jj)%cname(ji)
+                 IF ( clvarsin(ji) /= cdvars(ji) ) THEN
+                    CALL ctl_stop( 'Feedback file variables do not match', &
+                        &           ' expected variable names for this type' )
+                 ENDIF
                END DO
             ELSE
                DO ji = 1, inpfiles(jj)%nvar
-                  IF ( inpfiles(jj)%cname(ji) /= clvars(ji) ) THEN
+                  IF ( inpfiles(jj)%cname(ji) /= clvarsin(ji) ) THEN
                      CALL ctl_stop( 'Feedback file variables not consistent', &
                         &           ' with previous files for this type' )
@@ -265,8 +281,22 @@
 
             IF ( inpfiles(jj)%nobs > 0 ) THEN
-               inpfiles(jj)%iproc = -1
-               inpfiles(jj)%iobsi = -1
-               inpfiles(jj)%iobsj = -1
-            ENDIF
+               inpfiles(jj)%iproc(:,:) = -1
+               inpfiles(jj)%iobsi(:,:) = -1
+               inpfiles(jj)%iobsj(:,:) = -1
+            ENDIF
+
+            !If SLA observations are representing a time mean then set the time
+            !of the obs to the end of that meaning period relative to the start of the run
+            IF ( ln_time_mean_sla_bkg .AND. ( TRIM( clvarsin(1) ) == 'SLA' ) ) THEN
+               DO ji = 1, inpfiles(jj)%nobs
+                  ! Only do this for obs within time window
+                  IF ( ( inpfiles(jj)%ptim(ji) > djulini(jj) ) .AND. &
+                     & ( inpfiles(jj)%ptim(ji) <= djulend(jj) ) ) THEN
+	                  inpfiles(jj)%ptim(ji) = &
+	                        & djulini(jj) + (MeanPeriodHours/24.)
+                  ENDIF      
+	            END DO
+            ENDIF   
+            
             inowin = 0
             DO ji = 1, inpfiles(jj)%nobs
@@ -278,7 +308,7 @@
             ALLOCATE( zlam(inowin)  )
             ALLOCATE( zphi(inowin)  )
-            ALLOCATE( iobsi(inowin) )
-            ALLOCATE( iobsj(inowin) )
-            ALLOCATE( iproc(inowin) )
+            ALLOCATE( iobsi(inowin,kvars) )
+            ALLOCATE( iobsj(inowin,kvars) )
+            ALLOCATE( iproc(inowin,kvars) )
             inowin = 0
             DO ji = 1, inpfiles(jj)%nobs
@@ -291,5 +321,21 @@
             END DO
 
-            CALL obs_grid_search( inowin, zlam, zphi, iobsi, iobsj, iproc, 'T' )
+            ! Assume anything other than velocity is on T grid
+            IF ( TRIM( inpfiles(jj)%cname(1) ) == 'UVEL' ) THEN
+               CALL obs_grid_search( inowin, zlam, zphi, iobsi(:,1), iobsj(:,1), &
+                  &                  iproc(:,1), 'U' )
+               CALL obs_grid_search( inowin, zlam, zphi, iobsi(:,2), iobsj(:,2), &
+                  &                  iproc(:,2), 'V' )
+            ELSE
+               CALL obs_grid_search( inowin, zlam, zphi, iobsi(:,1), iobsj(:,1), &
+                  &                  iproc(:,1), 'T' )
+               IF ( kvars > 1 ) THEN
+                  DO jvar = 2, kvars
+                     iobsi(:,jvar) = iobsi(:,1)
+                     iobsj(:,jvar) = iobsj(:,1)
+                     iproc(:,jvar) = iproc(:,1)
+                  END DO
+               ENDIF
+            ENDIF
 
             inowin = 0
@@ -298,7 +344,9 @@
                   & ( inpfiles(jj)%ptim(ji) <= djulend(jj) )       ) THEN
                   inowin = inowin + 1
-                  inpfiles(jj)%iproc(ji,1) = iproc(inowin)
-                  inpfiles(jj)%iobsi(ji,1) = iobsi(inowin)
-                  inpfiles(jj)%iobsj(ji,1) = iobsj(inowin)
+                  DO jvar = 1, kvars
+                     inpfiles(jj)%iproc(ji,jvar) = iproc(inowin,jvar)
+                     inpfiles(jj)%iobsi(ji,jvar) = iobsi(inowin,jvar)
+                     inpfiles(jj)%iobsj(ji,jvar) = iobsj(inowin,jvar)
+                  END DO
                ENDIF
             END DO
@@ -359,13 +407,17 @@
          &               iindx   )
 
-      CALL obs_surf_alloc( surfdata, iobs, kvars, iextr, kstp, jpi, jpj )
+      CALL obs_surf_alloc( surfdata, iobs, kvars, iextr, kstp, jpi, jpj, ldclim )
 
       ! Read obs/positions, QC, all variable and assign to surfdata
 
       iobs = 0
-      surfdata%cvars(:)  = clvars(:)
+      surfdata%cvars(:)  = clvarsin(:)
       IF ( ldmod .AND. ( TRIM( surfdata%cvars(1) ) == 'SLA' ) ) THEN
          surfdata%cext(1) = 'SSH'
          surfdata%cext(2) = 'MDT'
+      ENDIF
+      IF ( ldmod .AND. ( TRIM( surfdata%cvars(1) ) == 'FBD' ) ) THEN
+           surfdata%cext(1) = 'freeboard'
+           surfdata%cext(2) = 'thick_s'
       ENDIF
       IF ( iextr > kextr ) surfdata%cext(iextr) = 'STD'
@@ -417,7 +469,9 @@
 
                ! Coordinate search parameters
-               surfdata%mi  (iobs) = inpfiles(jj)%iobsi(ji,1)
-               surfdata%mj  (iobs) = inpfiles(jj)%iobsj(ji,1)
-
+               DO jvar = 1, kvars
+                  surfdata%mi(iobs,jvar) = inpfiles(jj)%iobsi(ji,jvar)
+                  surfdata%mj(iobs,jvar) = inpfiles(jj)%iobsj(ji,jvar)
+               END DO
+               
                ! WMO number
                surfdata%cwmo(iobs) = inpfiles(jj)%cdwmo(ji)
@@ -449,9 +503,17 @@
 
                ! Observed value
-               surfdata%robs(iobs,1) = inpfiles(jj)%pob(1,ji,1)
+               DO jvar = 1, kvars               
+                  surfdata%robs(iobs,jvar) = inpfiles(jj)%pob(1,ji,jvar)
+               END DO
+               IF ( TRIM(surfdata%cvars(1)) == 'FBD' ) THEN
+                   surfdata%rext(iobs,1) = inpfiles(jj)%pob(1,ji,1)
+                   surfdata%rext(iobs,2) = fbrmdi
+               ENDIF
 
                ! Model and MDT is set to fbrmdi unless read from file
                IF ( ldmod ) THEN
-                  surfdata%rmod(iobs,1) = inpfiles(jj)%padd(1,ji,1,1)
+                  DO jvar = 1, kvars                              
+                     surfdata%rmod(iobs,jvar) = inpfiles(jj)%padd(1,ji,1,jvar)
+                  END DO
                   IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) THEN
                      surfdata%rext(iobs,1) = inpfiles(jj)%padd(1,ji,2,1)
@@ -459,8 +521,17 @@
                   ENDIF
                 ELSE
-                  surfdata%rmod(iobs,1) = fbrmdi
+                  DO jvar = 1, kvars                
+                     surfdata%rmod(iobs,jvar) = fbrmdi
+                  END DO
                   IF ( TRIM(surfdata%cvars(1)) == 'SLA' ) surfdata%rext(iobs,:) = fbrmdi
                ENDIF
-
+               
+               ! Initialise climatology if set
+               IF ( surfdata%lclim ) THEN
+                  DO jvar = 1, kvars
+                     surfdata%rclm(iobs,jvar) = fbrmdi
+                  END DO
+               ENDIF
+               
                ! STD (obs error standard deviation) read from file and passed through obs operator
                IF ( iadd_std(jj) /= -1 ) THEN
@@ -483,7 +554,14 @@
       !-----------------------------------------------------------------------
       IF (lwp) THEN
-
+         DO jvar = 1, surfdata%nvar       
+            IF ( jvar == 1 ) THEN
+               cout1=TRIM(surfdata%cvars(1))                  
+            ELSE
+               WRITE(cout1,'(A,A1,A)') TRIM(cout1), '/', TRIM(surfdata%cvars(jvar))            
+            ENDIF
+         END DO
+ 
          WRITE(numout,*)
-         WRITE(numout,'(1X,A)')TRIM( surfdata%cvars(1) )//' data'
+         WRITE(numout,'(1X,A)')TRIM( cout1 )//' data'
          WRITE(numout,'(1X,A)')'--------------'
          DO jj = 1,8
@@ -495,5 +573,5 @@
             & '---------------------------------------------------------------'
          WRITE(numout,'(1X,A,I8)') &
-            & 'Total data for variable '//TRIM( surfdata%cvars(1) )// &
+            & 'Total data for variable '//TRIM( cout1 )// &
             & '           = ', iobsmpp
          WRITE(numout,'(1X,A)') &
@@ -506,5 +584,5 @@
       ! Deallocate temporary data
       !-----------------------------------------------------------------------
-      DEALLOCATE( ifileidx, isurfidx, zdat, clvars )
+      DEALLOCATE( ifileidx, isurfidx, zdat, clvarsin )
 
       !-----------------------------------------------------------------------
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_readsnowdepth.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_readsnowdepth.F90	(revision 15764)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_readsnowdepth.F90	(revision 15764)
@@ -0,0 +1,152 @@
+MODULE obs_readsnowdepth
+   !!======================================================================
+   !!                       ***  MODULE obs_readsnowdepth  ***
+   !! Observation diagnostics: Get the snow depth for freeboard conversion to thickness
+   !!======================================================================
+   !! History :      ! 2018-10 (E. Fiedler) Initial version
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   obs_rea_snowdepth    : Driver for reading MDT
+   !!----------------------------------------------------------------------
+   USE wrk_nemo         ! Memory Allocation
+   USE par_kind         ! Precision variables
+   USE par_oce          ! Domain parameters
+   USE in_out_manager   ! I/O manager
+   USE obs_surf_def     ! Surface observation definitions
+   USE obs_inter_sup    ! Interpolation support routines
+   USE obs_inter_h2d    ! 2D interpolation
+   USE obs_utils        ! Various observation tools
+   USE iom_nf90         ! IOM NetCDF
+   USE netcdf           ! NetCDF library
+   USE lib_mpp          ! MPP library
+   USE dom_oce, ONLY : &                  ! Domain variables
+      &                    tmask, tmask_i, e1t, e2t, gphit, glamt
+   USE obs_const, ONLY :   obfillflt      ! Fillvalue
+   USE oce      , ONLY :   sshn           ! Model variables
+
+
+
+   IMPLICIT NONE
+   PRIVATE
+   
+   PUBLIC   obs_rea_snowdepth     ! called by dia_obs
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE obs_rea_snowdepth( fbddata, k2dint, thick_s )
+      !!---------------------------------------------------------------------
+      !!
+      !!                   *** ROUTINE obs_rea_snowdepth ***
+      !!
+      !! ** Purpose : Get snowdepth from CICE
+      !!
+      !! ** Method  : 
+      !!
+      !! ** Action  : 
+      !!----------------------------------------------------------------------
+      USE iom
+      !
+      TYPE(obs_surf), INTENT(inout)  ::   fbddata   ! Sea ice freeboard data
+      INTEGER       , INTENT(in)     ::   k2dint    ! ?
+      REAL(wp), INTENT(IN), DIMENSION(jpi,jpj) :: thick_s ! Model snow depth
+     
+      CHARACTER(LEN=12), PARAMETER ::   cpname  = 'obs_rea_snowdepth'
+
+      INTEGER ::   jobs                ! Obs loop variable
+      INTEGER ::   jpi_thick_s, jpj_thick_s      ! Number of grid point in lat/lon for the snow depth
+      INTEGER ::   iico, ijco          ! Grid point indices
+
+      !
+      REAL(wp), DIMENSION(1)     ::   zext, zobsmask
+      REAL(wp), DIMENSION(2,2,1) ::   zweig
+      !
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   zmask, z_thick_s_l, zglam, zgphi
+      INTEGER , DIMENSION(:,:,:), ALLOCATABLE ::   igrdi, igrdj
+      !
+      REAL(wp), POINTER, DIMENSION(:,:) ::  z_thick_s, thick_s_mask
+         
+      REAL(wp) :: zlam, zphi, zfill, zinfill    ! local scalar
+      !!----------------------------------------------------------------------
+
+      CALL wrk_alloc(jpi,jpj,z_thick_s,thick_s_mask) 
+
+      IF(lwp)WRITE(numout,*) 
+      IF(lwp)WRITE(numout,*) ' obs_rea_snowdepth : Get model snow depth for freeboard conversion to sea ice thickness'
+      IF(lwp)WRITE(numout,*) ' ------------- '
+      CALL FLUSH(numout)
+
+      ! Get ice thickness information
+      z_thick_s = thick_s
+
+      ! Setup mask based on tmask
+      thick_s_mask(:,:) = tmask(:,:,1)
+
+      ! Interpolate the snow depth already on the model grid at the observation point
+  
+      ALLOCATE( &
+         & igrdi(2,2,fbddata%nsurf), &
+         & igrdj(2,2,fbddata%nsurf), &
+         & zglam(2,2,fbddata%nsurf), &
+         & zgphi(2,2,fbddata%nsurf), &
+         & zmask(2,2,fbddata%nsurf), &
+         & z_thick_s_l(2,2,fbddata%nsurf)  &
+         & )
+         
+      DO jobs = 1, fbddata%nsurf
+
+         igrdi(1,1,jobs) = fbddata%mi(jobs)-1
+         igrdj(1,1,jobs) = fbddata%mj(jobs)-1
+         igrdi(1,2,jobs) = fbddata%mi(jobs)-1
+         igrdj(1,2,jobs) = fbddata%mj(jobs)
+         igrdi(2,1,jobs) = fbddata%mi(jobs)
+         igrdj(2,1,jobs) = fbddata%mj(jobs)-1
+         igrdi(2,2,jobs) = fbddata%mi(jobs)
+         igrdj(2,2,jobs) = fbddata%mj(jobs)
+
+      END DO
+
+      CALL obs_int_comm_2d( 2, 2, fbddata%nsurf, jpi, jpj, igrdi, igrdj, glamt  , zglam )
+      CALL obs_int_comm_2d( 2, 2, fbddata%nsurf, jpi, jpj, igrdi, igrdj, gphit  , zgphi )
+      CALL obs_int_comm_2d( 2, 2, fbddata%nsurf, jpi, jpj, igrdi, igrdj, thick_s_mask, zmask )
+      CALL obs_int_comm_2d( 2, 2, fbddata%nsurf, jpi, jpj, igrdi, igrdj, z_thick_s  , z_thick_s_l )
+
+      DO jobs = 1, fbddata%nsurf
+            
+         zlam = fbddata%rlam(jobs)
+         zphi = fbddata%rphi(jobs)
+
+         CALL obs_int_h2d_init( 1, 1, k2dint, zlam, zphi,         &
+            &                   zglam(:,:,jobs), zgphi(:,:,jobs), &
+            &                   zmask(:,:,jobs), zweig, zobsmask )
+            
+         CALL obs_int_h2d( 1, 1, zweig, z_thick_s_l(:,:,jobs),  zext )
+ 
+         fbddata%rext(jobs,2) = zext(1)
+
+! mark any masked data with a QC flag
+         IF( zobsmask(1) == 0 )   fbddata%nqc(jobs) = IBSET(fbddata%nqc(jobs),15)
+
+         END DO
+         
+      DEALLOCATE( &
+         & igrdi, &
+         & igrdj, &
+         & zglam, &
+         & zgphi, &
+         & zmask, &
+         & z_thick_s_l  &
+         & )
+
+      CALL wrk_dealloc(jpi,jpj,z_thick_s,thick_s_mask) 
+      IF(lwp)WRITE(numout,*) ' ------------- '
+      !
+   END SUBROUTINE obs_rea_snowdepth
+   
+   !!======================================================================
+END MODULE obs_readsnowdepth
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_rot_vel.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_rot_vel.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_rot_vel.F90	(revision 15764)
@@ -6,5 +6,6 @@
 
    !!----------------------------------------------------------------------
-   !!   obs_rotvel : Rotate velocity data into N-S,E-W directorions
+   !!   obs_rotvel_pro :  Rotate profile velocity data into N-S,E-W directions 
+   !!   obs_rotvel_surf : Rotate surface velocity data into N-S,E-W directions
    !!----------------------------------------------------------------------
    !! * Modules used   
@@ -17,4 +18,5 @@
    USE obs_utils                ! For error handling
    USE obs_profiles_def         ! Profile definitions
+   USE obs_surf_def             ! Surface definitions
    USE obs_inter_h2d            ! Horizontal interpolation
    USE obs_inter_sup            ! MPP support routines for interpolation
@@ -27,5 +29,6 @@
    PRIVATE
 
-   PUBLIC obs_rotvel            ! Rotate the observations
+   PUBLIC obs_rotvel_pro, &     ! Rotate the profile velocity observations 
+      &   obs_rotvel_surf       ! Rotate the surface velocity observations
 
    !!----------------------------------------------------------------------
@@ -37,5 +40,5 @@
 CONTAINS
 
-   SUBROUTINE obs_rotvel( profdata, k2dint, pu, pv )
+   SUBROUTINE obs_rotvel_pro( profdata, k2dint, pu, pv )
       !!---------------------------------------------------------------------
       !!
@@ -228,5 +231,189 @@
       CALL wrk_dealloc(jpi,jpj,zsingu,zcosgu,zsingv,zcosgv) 
 
-   END SUBROUTINE obs_rotvel
+   END SUBROUTINE obs_rotvel_pro
+
+   SUBROUTINE obs_rotvel_surf( surfdata, k2dint, pu, pv ) 
+      !!--------------------------------------------------------------------- 
+      !! 
+      !!                   *** ROUTINE obs_rotvel_surf *** 
+      !! 
+      !! ** Purpose : Rotate surface velocity data into N-S,E-W directorions 
+      !! 
+      !! ** Method  : Interpolation of geo2ocean coefficients on U,V grid 
+      !!              to observation point followed by a similar computations 
+      !!              as in geo2ocean. 
+      !! 
+      !! ** Action  : Review if there is a better way to do this. 
+      !! 
+      !! References :  
+      !! 
+      !! History :   
+      !!      ! :  2009-02 (K. Mogensen) : New routine 
+      !!---------------------------------------------------------------------- 
+      !! * Modules used 
+      !! * Arguments 
+      TYPE(obs_surf), INTENT(INOUT) :: surfdata    ! Surface data to be read 
+      INTEGER, INTENT(IN) :: k2dint     ! Horizontal interpolation methed 
+      REAL(wp), DIMENSION(*) :: & 
+         & pu, & 
+         & pv 
+      !! * Local declarations 
+      REAL(wp), DIMENSION(2,2,1) :: zweig 
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: & 
+         & zmasku, & 
+         & zmaskv, & 
+         & zcoslu, & 
+         & zsinlu, & 
+         & zcoslv, & 
+         & zsinlv, & 
+         & zglamu, & 
+         & zgphiu, & 
+         & zglamv, & 
+         & zgphiv 
+      REAL(wp), DIMENSION(1) :: & 
+         & zsinu, & 
+         & zcosu, & 
+         & zsinv, & 
+         & zcosv 
+      REAL(wp) :: zsin 
+      REAL(wp) :: zcos 
+      REAL(wp), DIMENSION(1) :: zobsmask 
+      REAL(wp), POINTER, DIMENSION(:,:) :: zsingu,zcosgu,zsingv,zcosgv 
+      INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: & 
+         & igrdiu, & 
+         & igrdju, & 
+         & igrdiv, & 
+         & igrdjv 
+      INTEGER :: ji 
+      INTEGER :: jk 
+
+      CALL wrk_alloc(jpi,jpj,zsingu,zcosgu,zsingv,zcosgv)  
+
+      !----------------------------------------------------------------------- 
+      ! Allocate data for message parsing and interpolation 
+      !----------------------------------------------------------------------- 
+
+      ALLOCATE( & 
+         & igrdiu(2,2,surfdata%nsurf), & 
+         & igrdju(2,2,surfdata%nsurf), & 
+         & zglamu(2,2,surfdata%nsurf), & 
+         & zgphiu(2,2,surfdata%nsurf), & 
+         & zmasku(2,2,surfdata%nsurf), & 
+         & zcoslu(2,2,surfdata%nsurf), & 
+         & zsinlu(2,2,surfdata%nsurf), & 
+         & igrdiv(2,2,surfdata%nsurf), & 
+         & igrdjv(2,2,surfdata%nsurf), & 
+         & zglamv(2,2,surfdata%nsurf), & 
+         & zgphiv(2,2,surfdata%nsurf), & 
+         & zmaskv(2,2,surfdata%nsurf), & 
+         & zcoslv(2,2,surfdata%nsurf), & 
+         & zsinlv(2,2,surfdata%nsurf)  & 
+         & ) 
+
+      !----------------------------------------------------------------------- 
+      ! Receive the angles on the U and V grids. 
+      !----------------------------------------------------------------------- 
+
+      CALL obs_rot( zsingu, zcosgu, zsingv, zcosgv ) 
+
+      DO ji = 1, surfdata%nsurf 
+         igrdiu(1,1,ji) = surfdata%mi(ji,1)-1 
+         igrdju(1,1,ji) = surfdata%mj(ji,1)-1 
+         igrdiu(1,2,ji) = surfdata%mi(ji,1)-1 
+         igrdju(1,2,ji) = surfdata%mj(ji,1) 
+         igrdiu(2,1,ji) = surfdata%mi(ji,1) 
+         igrdju(2,1,ji) = surfdata%mj(ji,1)-1 
+         igrdiu(2,2,ji) = surfdata%mi(ji,1) 
+         igrdju(2,2,ji) = surfdata%mj(ji,1) 
+         igrdiv(1,1,ji) = surfdata%mi(ji,2)-1 
+         igrdjv(1,1,ji) = surfdata%mj(ji,2)-1 
+         igrdiv(1,2,ji) = surfdata%mi(ji,2)-1 
+         igrdjv(1,2,ji) = surfdata%mj(ji,2) 
+         igrdiv(2,1,ji) = surfdata%mi(ji,2) 
+         igrdjv(2,1,ji) = surfdata%mj(ji,2)-1 
+         igrdiv(2,2,ji) = surfdata%mi(ji,2) 
+         igrdjv(2,2,ji) = surfdata%mj(ji,2) 
+      END DO 
+
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, & 
+         &                  glamu, zglamu ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, & 
+         &                  gphiu, zgphiu ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, & 
+         &                  umask(:,:,1), zmasku ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, & 
+         &                  zsingu, zsinlu ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiu, igrdju, & 
+         &                  zcosgu, zcoslu ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, & 
+         &                  glamv, zglamv ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, & 
+         &                  gphiv, zgphiv ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, & 
+         &                  vmask(:,:,1), zmaskv ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, & 
+         &                  zsingv, zsinlv ) 
+      CALL obs_int_comm_2d( 2, 2, surfdata%nsurf, jpi, jpj, igrdiv, igrdjv, & 
+         &                  zcosgv, zcoslv ) 
+
+      DO ji = 1, surfdata%nsurf 
+
+         CALL obs_int_h2d_init( 1, 1, k2dint, & 
+            &                   surfdata%rlam(ji), surfdata%rphi(ji), & 
+            &                   zglamu(:,:,ji), zgphiu(:,:,ji),       & 
+            &                   zmasku(:,:,ji), zweig, zobsmask ) 
+
+         CALL obs_int_h2d( 1, 1, zweig, zsinlu(:,:,ji),  zsinu ) 
+
+         CALL obs_int_h2d( 1, 1, zweig, zcoslu(:,:,ji),  zcosu ) 
+
+         CALL obs_int_h2d_init( 1, 1, k2dint, & 
+            &                   surfdata%rlam(ji), surfdata%rphi(ji), & 
+            &                   zglamv(:,:,ji), zgphiv(:,:,ji),       & 
+            &                   zmaskv(:,:,ji), zweig, zobsmask ) 
+
+         CALL obs_int_h2d( 1, 1, zweig, zsinlv(:,:,ji),  zsinv ) 
+
+         CALL obs_int_h2d( 1, 1, zweig, zcoslv(:,:,ji),  zcosv ) 
+
+         ! Assume that the angle at observation point is the  
+         ! mean of u and v cosines/sines 
+
+         zcos = 0.5_wp * ( zcosu(1) + zcosv(1) ) 
+         zsin = 0.5_wp * ( zsinu(1) + zsinv(1) ) 
+
+         IF ( ( surfdata%rmod(ji,1) /= fbrmdi ) .AND. & 
+            & ( surfdata%rmod(ji,2) /= fbrmdi ) ) THEN 
+            pu(ji) = surfdata%rmod(ji,1) * zcos - & 
+               &     surfdata%rmod(ji,2) * zsin 
+            pv(ji) = surfdata%rmod(ji,2) * zcos + & 
+               &     surfdata%rmod(ji,1) * zsin 
+         ELSE 
+            pu(ji) = fbrmdi 
+            pv(ji) = fbrmdi 
+         ENDIF 
+
+      END DO 
+
+      DEALLOCATE( & 
+         & igrdiu, & 
+         & igrdju, & 
+         & zglamu, & 
+         & zgphiu, & 
+         & zmasku, & 
+         & zcoslu, & 
+         & zsinlu, & 
+         & igrdiv, & 
+         & igrdjv, & 
+         & zglamv, & 
+         & zgphiv, & 
+         & zmaskv, & 
+         & zcoslv, & 
+         & zsinlv  & 
+         & ) 
+
+      CALL wrk_dealloc(jpi,jpj,zsingu,zcosgu,zsingv,zcosgv)  
+
+   END SUBROUTINE obs_rotvel_surf 
 
 END MODULE obs_rot_vel
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_surf_def.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_surf_def.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_surf_def.F90	(revision 15764)
@@ -52,9 +52,9 @@
       INTEGER :: nrec       !: Number of surface observation records in window
 
+      LOGICAL :: lclim      !: Climatology will be calculated for this structure
+
       ! Arrays with size equal to the number of surface observations
 
       INTEGER, POINTER, DIMENSION(:) :: &
-         & mi,   &        !: i-th grid coord. for interpolating to surface observation
-         & mj,   &        !: j-th grid coord. for interpolating to surface observation
          & mt,   &        !: time record number for gridded data
          & nsidx,&        !: Surface observation number
@@ -69,4 +69,8 @@
          & ntyp           !: Type of surface observation product
 
+      INTEGER, POINTER, DIMENSION(:,:) :: & 
+         & mi,   &        !: i-th grid coord. for interpolating to surface observation 
+         & mj             !: j-th grid coord. for interpolating to surface observation
+
       CHARACTER(len=8), POINTER, DIMENSION(:) :: &
          & cvars          !: Variable names
@@ -84,10 +88,11 @@
       REAL(KIND=wp), POINTER, DIMENSION(:,:) :: &
          & robs, &        !: Surface observation 
-         & rmod           !: Model counterpart of the surface observation vector
+         & rmod, &        !: Model counterpart of the surface observation vector 
+         & rclm           !: Climatological counterpart of the surface observation vector
 
       REAL(KIND=wp), POINTER, DIMENSION(:,:) :: &
          & rext           !: Extra fields interpolated to observation points
 
-      REAL(KIND=wp), POINTER, DIMENSION(:,:) :: &
+      REAL(KIND=wp), POINTER, DIMENSION(:,:,:) :: &
          & vdmean         !: Time averaged of model field
 
@@ -111,5 +116,4 @@
 
       ! Is this a gridded product?
-     
       LOGICAL :: lgrid
 
@@ -124,5 +128,5 @@
 CONTAINS
    
-   SUBROUTINE obs_surf_alloc( surf, ksurf, kvar, kextra, kstp, kpi, kpj )
+   SUBROUTINE obs_surf_alloc( surf, ksurf, kvar, kextra, kstp, kpi, kpj, ldclim )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE obs_surf_alloc  ***
@@ -143,4 +147,5 @@
       INTEGER, INTENT(IN) :: kpi     ! Number of 3D grid points
       INTEGER, INTENT(IN) :: kpj
+      LOGICAL, INTENT(IN) :: ldclim
 
       !!* Local variables
@@ -157,4 +162,5 @@
       surf%npi      = kpi
       surf%npj      = kpj
+      surf%lclim    = ldclim
 
       ! Allocate arrays of size number of variables
@@ -171,6 +177,4 @@
 
       ALLOCATE( &
-         & surf%mi(ksurf),      &
-         & surf%mj(ksurf),      &
          & surf%mt(ksurf),      &
          & surf%nsidx(ksurf),   &
@@ -196,8 +200,12 @@
 
       ALLOCATE( & 
+         & surf%mi(ksurf,kvar),   & 
+         & surf%mj(ksurf,kvar),   &
          & surf%robs(ksurf,kvar), &
          & surf%rmod(ksurf,kvar)  &
          & )   
 
+      IF (surf%lclim) ALLOCATE( surf%rclm(ksurf,kvar) )
+
       ! Allocate arrays of number of extra fields at observation points
 
@@ -223,5 +231,5 @@
 
       ALLOCATE( &
-         & surf%vdmean(kpi,kpj) &
+         & surf%vdmean(kpi,kpj,kvar) &
          & )
 
@@ -293,4 +301,5 @@
          & )
 
+      IF (surf%lclim) DEALLOCATE( surf%rclm )
       ! Deallocate arrays of number of extra fields at observation points
 
@@ -371,5 +380,5 @@
       IF ( lallocate ) THEN
          CALL obs_surf_alloc( newsurf,  insurf, surf%nvar, &
-            & surf%nextra, surf%nstp, surf%npi, surf%npj )
+            & surf%nextra, surf%nstp, surf%npi, surf%npj, surf%lclim )
       ENDIF
 
@@ -418,4 +427,5 @@
                newsurf%robs(insurf,jk)  = surf%robs(ji,jk)
                newsurf%rmod(insurf,jk)  = surf%rmod(ji,jk)
+               IF (newsurf%lclim) newsurf%rclm(insurf,jk) = surf%rclm(ji,jk)
                
             END DO
@@ -514,4 +524,5 @@
             oldsurf%robs(jj,jk)  = surf%robs(ji,jk)
             oldsurf%rmod(jj,jk)  = surf%rmod(ji,jk)
+            IF (surf%lclim) oldsurf%rclm(jj,jk)  = surf%rclm(ji,jk)
 
          END DO
